; Moschino's userlist manager designed to work with only the Moschino[FlashBuzzen] connection.
; GLOBALQ, GLOBALOP, GLOBALH, LOCALQ, LOCALOP, LOCALH and BANLIST userlevels supported.
; NOTE: sample 'on TEXT' commands are at the bottom - scroll down.
; -
; Please visit http://moschino.org.uk for updates/problems/suggesstions.
; Thanks, Dabba.


on *:START: {
  if ($Con_Version < 2.37) {
    echo -sace info *** Moschino[UserlistManager] will only work correctly on connection version 2.37 (onwards). $&
      Please update your Moschino[FlashBuzzen] connection.
  }
}

dialog Userlist {
  title Moschino[UserlistManager]1.3
  size -1 -1 248 177
  option dbu
}

on *:DIALOG:Userlist:INIT:0:{
  var %D = $Dname

  dcx Mark %D Userlist_Callback

  ; Border.
  xdialog -b %D +woty

  xdialog -c %D 1 tab 3 4 491 320
  xdid -a %D 1 0 1 Global +q $Chr(9) 123 panel 10 10 400 25
  xdid -a %D 1 0 1 Global +o $Chr(9) 124 panel 10 10 400 25
  xdid -a %D 1 0 1 Global +h $Chr(9) 125 panel 10 10 400 25
  xdid -a %D 1 0 1 Local +q $Chr(9) 126 panel 10 10 400 25
  xdid -a %D 1 0 1 Local +o $Chr(9) 127 panel 10 10 400 25
  xdid -a %D 1 0 1 Local +h $Chr(9) 128 panel 10 10 400 25
  xdid -a %D 1 0 1 Banlist $Chr(9) 129 panel 10 10 400 25

  ; Global +q
  xdid -c %D 123 10 listview 2 5 480 287 report grid borderselect flatsb fullrow
  xdid -t %D 10 +l 0 180 Ial (right-click entries) $Chr(9) +l 0 130 Log name $Chr(9) +l 0 400 Reason

  ; Global +o
  xdid -c %D 124 11 listview 2 5 480 287 report grid borderselect flatsb fullrow
  xdid -t %D 11 +l 0 180 Ial (right-click entries) $Chr(9) +l 0 130 Log name $Chr(9) +l 0 400 Reason

  ; Global +h
  xdid -c %D 125 12 listview 2 5 480 287 report grid borderselect flatsb fullrow
  xdid -t %D 12 +l 0 180 Ial (right-click entries) $Chr(9) +l 0 130 Log name $Chr(9) +l 0 400 Reason

  ; Local +q
  xdid -c %D 126 13 listview 2 5 480 287 report grid borderselect flatsb fullrow
  xdid -t %D 13 +l 0 180 Ial (right-click entries) $Chr(9) +l 0 130 Log name $Chr(9) +l 0 150 Localq channel $Chr(9) +l 0 400 Reason

  ; Local +o
  xdid -c %D 127 14 listview 2 5 480 287 report grid borderselect flatsb fullrow
  xdid -t %D 14 +l 0 180 Ial (right-click entries) $Chr(9) +l 0 130 Log name $Chr(9) +l 0 150 Localop channel $Chr(9) +l 0 400 Reason

  ; Local +h
  xdid -c %D 128 15 listview 2 5 480 287 report grid borderselect flatsb fullrow
  xdid -t %D 15 +l 0 180 Ial (right-click entries) $Chr(9) +l 0 130 Log name $Chr(9) +l 0 150 Localh channel $Chr(9) +l 0 400 Reason

  ; Banlist
  xdid -c %D 129 16 listview 2 5 528 254 report grid borderselect flatsb fullrow
  xdid -t %D 16 +l 0 180 Ial (right-click entries) $Chr(9) +l 0 130 Log name $Chr(9) +l 0 400 Banlist reason

  xdid -c %D 129 454 check 2 270 180 16
  xdid -t %D 454 Clear owner/host on kicks
  if ($Group(#CLEAR_OWNER_HOST) == on) xdid -c %D 454

  xdid -c %D 129 456 button 332 266 150 25
  xdid -t %D 456 Add a custom banlist entry

  xdid -l %D 10,11,12,13,14,15,16 16 1 0 0
  xdid -w %D 10,11,12,13,14,15,16 +n 0 $MircdirIcons/user.ico

  ; Button.
  xdialog -c %D 6546 button 423 329 70 25
  xdid -l %D 6546 16
  xdid -w %D 6546 +n 0 $MircdirIcons/Settings.ico
  xdid -t %D 6546 Ok

  ; Link.
  xdialog -c %D 19 text 3 335 135 23
  xdid -t %D 19 $MainSettings(CONNECTION, LINK)
  xdid -f %D 19 +au ansi 8 Verdana
  xdid -C %D 19 +t $Rgb(0, 0, 255)

  ; Font.
  xdid -f %D 1 +a ansi 8 Verdana
  xdid -f %D 10,6546,11,12,13,14,15,16,454,456 +a ansi 8 Tahoma

  Load_Userlist GLOBALQ
  Load_Userlist GLOBALOP
  Load_Userlist GLOBALH

  Load_Userlist LOCALQ
  Load_Userlist LOCALOP
  Load_Userlist LOCALH

  Load_ABAN_List
}

alias Userlist_Callback {
  if ($2 == RCLICK) {
    if ($3 == 10) || ($3 == 11) || ($3 == 12) || ($3 == 13) || ($3 == 14) || ($3 == 15) || ($3 == 16) && ($4-) {
      var %Menu

      if ($3 == 10) %Menu = GLOBALQ_LISTVIEW
      elseif ($3 == 11) %Menu = GLOBALOP_LISTVIEW
      elseif ($3 == 12) %Menu = GLOBALH_LISTVIEW
      elseif ($3 == 13) %Menu = LOCALQ_LISTVIEW
      elseif ($3 == 14) %Menu = LOCALOP_LISTVIEW
      elseif ($3 == 15) %Menu = LOCALH_LISTVIEW
      elseif ($3 == 16) %Menu = ABAN_LISTVIEW

      if ($xpopup(%Menu).ismenu) xpopup -d %Menu

      xpopup -c %Menu verticalrev 

      xpopup -p %Menu $Rgb(255, 255, 255) $Rgb(119, 136, 153) $Rgb(112, 128, 144) $&
        $Rgb(119, 136, 153) $Rgb(119, 136, 153) $Rgb(119, 136, 153) $&
        $Rgb(248, 248, 255)

      xpop -a %Menu 0 $Chr(9) +g 1 0 Address: $Left($xdid($1, $3, 1).seltext, 20) $+ ..
      xpop -a %Menu 0 $Chr(9) +g 1 0 Nickname: $Buzz.decode($xdid($1, $3, 2).seltext)
      xpop -a %Menu 0 $Chr(9) + 2 0 -
      xpop -a %Menu 0 $Chr(9) + 3 0 Remove entry
      xpop -a %Menu 0 $Chr(9) + 4 0 Edit entry

      xpopup -s %Menu + $Mouse.dx $Mouse.dy
    }
  }

  elseif ($2 == LBDOWN) {
    if ($3 == 454) {
      var %State = $xdid($1, $3).state

      if (%State == 0) .enable #CLEAR_OWNER_HOST
      else .disable #CLEAR_OWNER_HOST
    }
  }

  elseif ($2 == SCLICK) {

    if ($3 == 19) RUN $xdid($1, 19).text

    elseif ($3 == 6546) dialog -x $1

    elseif ($3 == 456) {
      var %Ial = $Input(Please enter the users address., qe, ABAN address, whatever@@BuzzenPassport)

      if (%Ial) var %Nick = $Input(Please enter the users nickname., qe, ABAN nickname, John)

      if (%Nick) var %Reason = $Input(Please enter an ABAN message for user %Nick $+ ., qe, ABAN message, You're a dipshit.)

      if (%Reason) {
        writeini $Fp(data/Aban.ini) ABAN %Ial %Nick %Reason

        xdid -r Userlist 16
        Load_ABAN_List
      }
    }

  }
}

; Do _NOT_ remove or edit this line. The version checker uses it.
alias UserlistManager_Version return 1.3

alias Aop_File return $Fp(data/Aop.ini)

alias Aban_File return $Fp(data/Aban.ini)

alias Load_Userlist {
  var %File = $Aop_File, %Section = $$1

  if ($Ini(%File, %Section, 0)) {
    var %x 1
    while (%x <= $Ini(%File, %Section, 0)) {
      var %Ial = $Ini(%File, %Section, %x), %Info = $Aop_Read(%Section, %Ial)

      tokenize 32 %Info

      if (%Section == GLOBALQ) xdid -a Userlist 10 0 0 + 1 2 0 0 0 0 %Ial $Chr(9) -2 0 0 0 0 $Buzz.decode($1) $Chr(9) -2 0 0 0 0 $2-

      elseif (%Section == GLOBALOP) xdid -a Userlist 11 0 0 + 1 2 0 0 0 0 %Ial $Chr(9) -2 0 0 0 0 $Buzz.decode($1) $Chr(9) -2 0 0 0 0 $2-

      elseif (%Section == GLOBALH) xdid -a Userlist 12 0 0 + 1 2 0 0 0 0 %Ial $Chr(9) -2 0 0 0 0 $Buzz.decode($1) $Chr(9) -2 0 0 0 0 $2-


      elseif (%Section == LOCALQ) {
        var %_Ial = $Gettok(%Ial, 1, 37), %Chan = $+($Chr(37), $Gettok(%Ial, 2, 37))

        xdid -a Userlist 13 0 0 + 1 2 0 0 0 0 %_Ial $Chr(9) -2 0 0 0 0 $Buzz.decode($1) $Chr(9) -2 0 0 0 0 %Chan $Chr(9) -2 0 0 0 0 $2-
      }

      elseif (%Section == LOCALOP) {
        var %_Ial = $Gettok(%Ial, 1, 37), %Chan = $+($Chr(37), $Gettok(%Ial, 2, 37))

        xdid -a Userlist 14 0 0 + 1 2 0 0 0 0 %_Ial $Chr(9) -2 0 0 0 0 $Buzz.decode($1) $Chr(9) -2 0 0 0 0 %Chan $Chr(9) -2 0 0 0 0 $2-
      }

      elseif (%Section == LOCALH) {
        var %_Ial = $Gettok(%Ial, 1, 37), %Chan = $+($Chr(37), $Gettok(%Ial, 2, 37))

        xdid -a Userlist 15 0 0 + 1 2 0 0 0 0 %_Ial $Chr(9) -2 0 0 0 0 $Buzz.decode($1) $Chr(9) -2 0 0 0 0 %Chan $Chr(9) -2 0 0 0 0 $2-
      }

      inc %x
    }
  }
}

alias Load_ABAN_List {
  var %File = $Aban_File

  if ($Ini(%File, ABAN, 0)) {
    var %x 1
    while (%x <= $Ini(%File, ABAN, 0)) {
      var %Ial = $Ini(%File, ABAN, %x), %Info = $Readini(%File, ABAN, %Ial)

      tokenize 32 %Info
      xdid -a Userlist 16 0 0 + 1 2 0 0 0 0 %Ial $Chr(9) -2 0 0 0 0 $Buzz.decode($1) $Chr(9) -2 0 0 0 0 $2-

      inc %x
    }
  }
}

alias Edit_Reason {
  var %Type = $$1, %Ial = $$2

  if (%Type == GLOBALQ) || (%Type == GLOBALOP) || (%Type == GLOBALH) {
    tokenize 32 $Aop_Read(%Type, %Ial)

    var %NewReason = $Input(Please change the %Type reason for this user as required., qe, %Type message edit, $2-)

    if (%NewReason) { 
      Aop_Remove %Type %Ial
      writeini $Aop_File %Type %Ial $1 %NewReason

      xdid -r Userlist $Iif(%Type == GLOBALQ, 10, $Iif(%Type == GLOBALOP, 11, 12))
      Load_Userlist %Type
    }
  } 

  elseif (%Type == LOCALQ) || (%Type == LOCALOP) || (%Type == LOCALH) {
    tokenize 32 $Aop_Read(%Type, %Ial)

    var %NewReason = $Input(Please change the %Type reason for this user as required., qe, %Type message edit, $2-)

    if (%NewReason) { 
      Aop_Remove %Type %Ial
      writeini $Aop_File %Type %Ial $1 %NewReason

      xdid -r Userlist $Iif(%Type == LOCALQ, 13, $Iif(%Type == LOCALOP, 14, 15))
      Load_Userlist %Type
    }
  } 

  elseif (%Type == ABAN) {
    tokenize 32 $Aban_Read(ABAN, %Ial)

    var %NewReason = $Input(Please change the ABAN reason for this user as required., qe, Aban message edit, $2-)

    if (%NewReason) { 
      remini $Aban_File ABAN %Ial
      writeini $Aban_File ABAN %Ial $1 %NewReason

      xdid -r Userlist 16
      Load_ABAN_List
    }
  } 
}

alias Remove_Userlist {
  var %Type = $$1, %Ial = $$2

  var %Confirm = $Input(Are you sure you would like to remove this user from %Type $+ ?, y, %Type removal)

  if (%Confirm) {
    if (%Type == GLOBALQ) || (%Type == GLOBALOP) || (%Type == GLOBALH) {
      Aop_Remove %Type %Ial

      xdid -r Userlist $Iif(%Type == GLOBALQ, 10, $Iif(%Type == GLOBALOP, 11, 12))
      Load_Userlist $Iif(%Type == GLOBALQ, GLOBALQ, GLOBALOP)
    }

    elseif (%Type == LOCALQ) || (%Type == LOCALOP) || (%Type == LOCALH) {
      Aop_Remove %Type %Ial

      xdid -r Userlist $Iif(%Type == LOCALQ, 13, $Iif(%Type == LOCALOP, 14, 15))
      Load_Userlist %Type
    }

    elseif (%Type == ABAN) {
      remini $Aban_File ABAN %Ial

      xdid -r Userlist 16
      Load_ABAN_List
    }
  }
}

alias Aop_Read return $Readini($Aop_File, n, $1, $2)

alias Aop_Write writeini $Aop_File $1 $2 $3- 

alias Aop_Remove remini $Aop_File $1 $2

alias Is_Globalq return $Iif($Aop_Read(GLOBALQ, $$1), $True, $False)

alias Is_Globalo return $Iif($Aop_Read(GLOBALOP, $$1), $True, $False)

alias Is_Globalh return $Iif($Aop_Read(GLOBALH, $$1), $True, $False)

alias Is_Localq return $Iif($Aop_Read(LOCALQ, $$1 $+ $$2), $True, $False)

alias Is_Localo return $Iif($Aop_Read(LOCALOP, $$1 $+ $$2), $True, $False)

alias Is_Localh return $Iif($Aop_Read(LOCALH, $$1 $+ $$2), $True, $False)

alias UserlistInfo {
  var %Ial = $$1, %Type = $$2

  if ($PROP == ENTRY) return $Aop_Read(%Type, %Ial)

  elseif ($PROP == NICKLOG) return $Gettok($Aop_Read(%Type, %Ial), 1, 32)

  elseif ($PROP == REASON) return $Gettok($Aop_Read(%Type, %Ial), 2-, 32)
}

alias Aop_Add {
  var %Nick = $$1, %Ial = $Ial(%Nick).addr, %Type = $$2, %Mode = $Iif($Right(%Type, 1) == q, +q, $Iif($Right(%Type, 1) == h, +h, +o))

  if (!%Ial) {
    echo -ae * No Ial stored for %Nick $+ , //who'ing channel $+ .. please try again.
    sockwrite -n $C_Sock(#) WHO #

    return
  }

  if (%Nick == $Me) {
    echo -ae * You're trying to add yourself to aop? Silly you.

    return
  }

  if (*@BCN* iswm $Ial(%Nick).addr) {
    echo -ae * You're trying to add a staff user to your aop. Silly you.

    return
  }

  ; GLOBALQ
  if (%Type == GLOBALQ) {
    if ($Is_Globalo(%Ial)) {
      echo -ae * %Nick is on GLOBALOP, consider removing %Nick from GLOBALOP before adding him/her to GLOBALQ.
      return
    }

    elseif ($Is_Globalh(%Ial)) {
      echo -ae * %Nick is on GLOBALH, consider removing %Nick from GLOBALH before adding him/her to GLOBALQ.
      return
    }

    elseif ($Is_Globalq(%Ial)) { 
      echo -ae * %Nick is already on GLOBALQ.
      return 
    }
  }

  ; GLOBALOP
  elseif (%Type == GLOBALOP) {
    if ($Is_Globalq(%Ial)) { 
      echo -ae * %Nick is on GLOBALQ, consider removing %Nick from GLOBALQ before adding him/her to GLOBALOP.
      return 
    }

    elseif ($Is_Globalh(%Ial)) {
      echo -ae * %Nick is on GLOBALH, consider removing %Nick from GLOBALH before adding him/her to GLOBALOP.
      return
    }

    elseif ($Is_Globalo(%Ial)) {
      echo -ae * %Nick is already on GLOBALOP.
      return
    }
  }

  ; GLOBALH
  elseif (%Type == GLOBALH) {
    if ($Is_Globalq(%Ial)) { 
      echo -ae * %Nick is on GLOBALQ, consider removing %Nick from GLOBALQ before adding him/her to GLOBALH.
      return 
    }

    elseif ($Is_Globalo(%Ial)) {
      echo -ae * %Nick is on GLOBALOP, consider removing %Nick from GLOBALOP before adding him/her to GLOBALH.
      return
    }

    elseif ($Is_Globalh(%Ial)) {
      echo -ae * %Nick is already on GLOBALH.
      return
    }
  }


  ; LOCALQ
  elseif (%Type == LOCALQ) {
    if ($Is_Localo(%Ial, #)) {
      echo -ae * %Nick is on LOCALOP for this channel, consider removing %Nick from $&
        LOCALOP before adding him/her to LOCALQ for this channel.

      return
    }

    elseif ($Is_Localh(%Ial, #)) {
      echo -ae * %Nick is on LOCALH for this channel, consider removing %Nick from $&
        LOCALH before adding him/her to LOCALQ for this channel.

      return
    }

    elseif ($Is_Localq(%Ial, #)) {
      echo -ae * %Nick is already on LOCALQ for this channel.
      return
    }
  }

  ; LOCALOP
  elseif (%Type == LOCALOP) {
    if ($Is_Localh(%Ial, #)) {
      echo -ae * %Nick is on LOCALH for this channel, consider removing %Nick from $&
        LOCALH before adding him/her to LOCALOP for this channel.

      return
    }

    elseif ($Is_Localq(%Ial, #)) {
      echo -ae * %Nick is on LOCALQ for this channel, consider removing %Nick from $&
        LOCALQ before adding him/her to LOCALOP for this channel.

      return
    }

    elseif ($Is_Localo(%Ial, #)) {
      echo -ae * %Nick is already on LOCALOP for this channel.
      return
    }
  }


  ; LOCALH
  elseif (%Type == LOCALH) {
    if ($Is_Globalq(%Ial)) { 
      echo -ae * %Nick is on GLOBALQ, why would you want to add him/her to LOCALH for this channel?
      return 
    }

    elseif ($Is_Globalo(%Ial)) {
      echo -ae * %Nick is on GLOBALOP, why would you want to add him/her to LOCALH for this channel?
      return
    }

    elseif ($Is_Localq(%Ial, #)) {
      echo -ae * %Nick is on LOCALQ for this channel, consider removing %Nick from $&
        LOCALQ before adding him/her to LOCALH for this channel.

      return
    }

    elseif ($Is_Localo(%Ial, #)) {
      echo -ae * %Nick is on LOCALOP for this channel, consider removing %Nick from $&
        LOCALOP before adding him/her to LOCALH for this channel.

      return
    }

    elseif ($Is_Localh(%Ial, #)) {
      echo -ae * %Nick is already on LOCALH for this channel.
      return
    }
  }

  var %Reason

  if ($3 == MASS_SELECTION) %Reason = $4-

  else {
    %Reason = $Input(Please enter a message for your user. $+ $Str($Crlf, 2) $+ $&
      This user will receive %Mode from you everytime $+ $Chr(44) in $Iif(*LOCAL* iswm %Type, this channel: #, all the channels which you are %Mode in.), $&
      qe, %Type message, You rootmonkey!)
  }

  if (%Reason) {
    if (*LOCAL* iswm %Type) %Ial = $+(%Ial, #)

    Aop_Write %Type %Ial %Nick %Reason
    $Iif($3 == MASS_SELECTION, que 500 msg $Chr(37) $!+ $Mid(#, 2), msg #) * %Type added $+ $Iif(*LOCAL* iswm %Type, $Chr(32) for this channel:, :) %Nick $Smarks($UserlistInfo(%Ial, %Type).REASON)
  }
}

alias Mass_Select_Add {
  var %Type = $$1, %Users = $Replace($2-, $Chr(44), $Chr(32)), %Added, %Total = $Numtok(%Users, 32), $&
    %Confirm = $Input(Are you sure you would like to add all these users to %Type $+ ? $+ $Str($CrLf, 2) $+ $&
    $Buzz.decode(%Users), y, Mass select %Type)

  if ($Me isin %Users) {
    echo -ea * You selected yourself, re-select users *WITHOUT* selecting yourself.
    return
  }

  linesep

  if (%Confirm) {
    var %Reason = $Input(Please enter a message for your users., qe, %Type message, Mass selected %Type rootmonkies.)

    if (%Reason) {

      var %x 1
      while (%x <= %Total) {
        var %Nick = $Gettok(%Users, %x, 32), %Ial = $Ial(%Nick).addr

        if (%Ial) {
          Aop_Add %Nick %Type MASS_SELECTION %Reason
        }

        else {
          echo -a * Unable to add %Nick to %Type - no ial stored for this user. Try again for this user.
          que 10 WHOIS %Nick
        }

        inc %x
      }
    }
  }
  echo -a -
  ;if (%Added) echo # * %Type mass select added $+ $Iif(*LOCAL* iswm %Type, $Chr(32) for this channel:, :) %Added .. with reason: %Reason
}

alias Aop_Delete {
  var %Nick = $$1, %Ial = $Ial(%Nick).addr, %Type = $$2

  if (!%Ial) {
    echo -ae * No Ial stored for %Nick $+ , /whois'ing %Nick $+ .. try again.
    WHOIS %Nick
    return
  }

  if (%Type == GLOBALQ) {
    if (!$Is_Globalq(%Ial)) { 
      echo -ae * %Nick is not even on GLOBALQ.
      return 
    }
  }

  elseif (%Type == GLOBALOP) {
    if (!$Is_Globalo(%Ial)) { 
      echo -ae * %Nick is not even on GLOBALOP.
      return 
    }
  }

  elseif (%Type == GLOBALH) {
    if (!$Is_Globalh(%Ial)) { 
      echo -ae * %Nick is not even on GLOBALH.
      return 
    }
  }

  elseif (%Type == LOCALQ) {
    if (!$Is_Localq(%Ial, #)) { 
      echo -ae * %Nick is not even on LOCALQ for this channel.
      return 
    }
  }

  elseif (%Type == LOCALOP) {
    if (!$Is_Localo(%Ial, #)) { 
      echo -ae * %Nick is not even on LOCALOP for this channel. 
      return 
    }
  }

  elseif (%Type == LOCALH) {
    if (!$Is_Localh(%Ial, #)) {
      echo -ae * %Nick is not even on LOCALH for this channel. 
      return 
    }
  }

  Aop_Remove %Type %Ial $+ $Iif(*LOCAL* iswm %Type, #, )

  msg # * %Type removed $+ $Iif(*LOCAL* iswm %Type, $Chr(32) for this channel:, :) %Nick - %Ial
}

alias Channel_Aop_Scan { 
  var %x = 1, %Found_Users = 0, %Type = $$1

  msg # * Scanning %Type $Iif(*LOCAL* iswm %Type, for this channel) $+ ..

  while (%x <= $Nick(#, 0)) {

    var %N = $Nick(#, %x), %Ial = $Ial(%N).addr

    if (%Ial) {

      if (%Type == GLOBALQ) && ($Is_Globalq(%Ial)) { 
        que 500 msg $Chr(37) $!+ $Mid(#, 2) * Found %N $+ .. log: $UserlistInfo(%Ial, %Type).NICKLOG ; $Smarks($UserlistInfo(%Ial, %Type).REASON)

        inc %Found_Users 1
        if ($Nick(#, $Me, '.)) && ($Aop_Read(%Type $+ HALT, #) != Halted) que 500 sockwrite -n $C_Sock(#) MODE $Chr(37) $!+ $Mid(#, 2) +q %N
      }

      elseif (%Type == GLOBALOP) && ($Is_Globalo(%Ial)) { 
        que 500 msg $Chr(37) $!+ $Mid(#, 2) * Found %N $+ .. log: $UserlistInfo(%Ial, %Type).NICKLOG ; $Smarks($UserlistInfo(%Ial, %Type).REASON)

        inc %Found_Users 1
        if ($Nick(#, $Me, '.@)) && ($Aop_Read(%Type $+ HALT, #) != Halted) que 500 sockwrite -n $C_Sock(#) MODE $Chr(37) $!+ $Mid(#, 2) +o %N
      }

      elseif (%Type == GLOBALH) && ($Is_Globalh(%Ial)) { 
        que 500 msg $Chr(37) $!+ $Mid(#, 2) * Found %N $+ .. log: $UserlistInfo(%Ial, %Type).NICKLOG ; $Smarks($UserlistInfo(%Ial, %Type).REASON)

        inc %Found_Users 1
        if ($Nick(#, $Me, '.@)) && ($Aop_Read(%Type $+ HALT, #) != Halted) que 500 sockwrite -n $C_Sock(#) MODE $Chr(37) $!+ $Mid(#, 2) +h %N
      }


      elseif (%Type == LOCALQ) && ($Is_Localq(%Ial, #)) {
        que 500 msg $Chr(37) $!+ $Mid(#, 2) * Found %N $+ .. log: $UserlistInfo(%Ial $+ #, %Type).NICKLOG ; $Smarks($UserlistInfo(%Ial $+ #, %Type).REASON)

        inc %Found_Users 1
        que 500 sockwrite -n $C_Sock(#) MODE $Chr(37) $!+ $Mid(#, 2) +q %N
      }

      elseif (%Type == LOCALOP) && ($Is_Localo(%Ial, #)) {
        que 500 msg $Chr(37) $!+ $Mid(#, 2) * Found %N $+ .. log: $UserlistInfo(%Ial $+ #, %Type).NICKLOG ; $Smarks($UserlistInfo(%Ial $+ #, %Type).REASON)

        inc %Found_Users 1
        que 500 sockwrite -n $C_Sock(#) MODE $Chr(37) $!+ $Mid(#, 2) +o %N
      }

      elseif (%Type == LOCALH) && ($Is_Localh(%Ial, #)) {
        que 500 msg $Chr(37) $!+ $Mid(#, 2) * Found %N $+ .. log: $UserlistInfo(%Ial $+ #, %Type).NICKLOG ; $Smarks($UserlistInfo(%Ial $+ #, %Type).REASON)

        inc %Found_Users 1
        que 500 sockwrite -n $C_Sock(#) MODE $Chr(37) $!+ $Mid(#, 2) +h %N
      }
    }

    inc %x
  }

  que 500 msg $Chr(37) $!+ $Mid(#, 2) * %Type end; found %Found_Users $+ / $+ $Iif($Ini($Aop_File, %Type, 0), $Ifmatch, 0) $+ $&
    $Iif(*GLOBAL* iswm %Type, .. $RBracks(Channel halted: $Iif($Aop_Read(%Type $+ HALT, #) == Halted, Yes, No)), .)
}

alias Userlist_Halt { 
  var %Type = $Iif($$1 == GLOBALQ, GLOBALQHALT, $Iif($$1 == GLOBALOP, GLOBALOPHALT, GLOBALHHALT))
  Aop_Write %Type # Halted

  msg # * $$1 halted for this channel. 
}

alias Userlist_Unhalt { 
  var %Type = $Iif($$1 == GLOBALQ, GLOBALQHALT, $Iif($$1 == GLOBALOP, GLOBALOPHALT, GLOBALHHALT))
  Aop_Remove %Type # Halted

  msg # * $$1 unhalted for this channel.  
}

on *:JOIN:#: {
  var %N = $Nick, %Ial = $Ial($Nick).addr

  if (*MCHAN* iswm $Server) return


  ; GLOBALS
  if ($Is_Globalq(%Ial)) && ($Nick(#, $Me, '.)) {
    if ($Aop_Read(GLOBALQHALT, #) != Halted) {     
      msg # * GLOBALQ: %N $RBracks($UserlistInfo(%Ial, GLOBALQ).NICKLOG) $Smarks($UserlistInfo(%Ial, GLOBALQ).REASON)) .. 2 secs.
      que 2000 MODE $!Chr(37) $!+ $Right(#, -1) +q %N
    }

    elseif ($Aop_Read(GLOBALQHALT, #) == Halted) {
      msg # * GLOBALQ: $Nick $RBracks($UserlistInfo(%Ial, GLOBALQ).NICKLOG) $&
        $Smarks($UserlistInfo(%Ial, GLOBALQ).REASON)) .. halted for this channel.  
    }
  }

  elseif ($Is_Globalo(%Ial)) && ($Me isop #) { 
    if ($Aop_Read(GLOBALOPHALT, #) != Halted) {     
      msg # * GLOBALOP: %N $RBracks($UserlistInfo(%Ial, GLOBALOP).NICKLOG) $Smarks($UserlistInfo(%Ial, GLOBALOP).REASON)) .. 2 secs.

      if ($Nick !isop #) que 2000 MODE $!Chr(37) $!+ $Right(#, -1) +o %N
    }

    elseif ($Aop_Read(GLOBALOPHALT, #) == Halted) {
      msg # * GLOBALOP: $Nick $RBracks($UserlistInfo(%Ial, GLOBALOP).NICKLOG) $&
        $Smarks($UserlistInfo(%Ial, GLOBALOP).REASON)) .. halted for this channel.  
    }
  }

  elseif ($Is_Globalh(%Ial)) && ($Me isop #) { 
    if ($Aop_Read(GLOBALHHALT, #) != Halted) {     
      msg # * GLOBALH: %N $RBracks($UserlistInfo(%Ial, GLOBALH).NICKLOG) $Smarks($UserlistInfo(%Ial, GLOBALH).REASON)) .. 2 secs.

      if ($Nick !isop #) que 2000 MODE $!Chr(37) $!+ $Right(#, -1) +h %N
    }

    elseif ($Aop_Read(GLOBALHHALT, #) == Halted) {
      msg # * GLOBALH: $Nick $RBracks($UserlistInfo(%Ial, GLOBALH).NICKLOG) $&
        $Smarks($UserlistInfo(%Ial, GLOBALH).REASON)) .. halted for this channel.  
    }
  }


  ; LOCALS
  elseif ($Is_Localq(%Ial, #)) && ($Nick(#, $Me, '.)) {
    msg # * LOCALQ: %N $RBracks($UserlistInfo(%Ial $+ #, LOCALQ).NICKLOG) $Smarks($UserlistInfo(%Ial $+ #, LOCALQ).REASON)) .. 2 secs.
    que 2000 MODE $!Chr(37) $!+ $Right(#, -1) +q %N
  }

  elseif ($Is_Localo(%Ial, #)) && ($Me isop #) {
    msg # * LOCALOP: %N $RBracks($UserlistInfo(%Ial $+ #, LOCALOP).NICKLOG) $Smarks($UserlistInfo(%Ial $+ #, LOCALOP).REASON)) .. 2 secs.

    if ($Nick !isop #) que 2000 MODE $!Chr(37) $!+ $Right(#, -1) +o %N
  }

  elseif ($Is_Localh(%Ial, #)) && ($Me isop #) {
    msg # * LOCALH: %N $RBracks($UserlistInfo(%Ial $+ #, LOCALH).NICKLOG) $Smarks($UserlistInfo(%Ial $+ #, LOCALH).REASON)) .. 2 secs.

    if ($Nick !isop #) que 2000 MODE $!Chr(37) $!+ $Right(#, -1) +h %N
  }


  elseif ($Is_Aban(%Ial)) {
    var %F = $Aban_File

    if ($Is_Aban_Halt(#)) && ($Me isop #) && (%N !isop #) { 
      msg # * Banlisted fag $RBracks($Aban_Read(ABAN, %Ial)) .. halted for this channel. [Lucky retard]
    }
    else {
      if (!$Is_Aban_Halt(#)) && ($Me isop #) {
        tokenize 32 $Aban_Read(ABAN, %Ial)

        sockwrite -n $C_Sock(#) KICK # %N $+(aban:, $Chr(32), $1, $Chr(32), ; , $Chr(32), $2-) $&
          $+ $Crlf $+ ACCESS # ADD DENY *!* $+ %Ial 0 $+(:, %N was banlisted by $Me at $Time on $Date) $&
          $Iif($Group(#CLEAR_OWNER_HOST) == on, $+ $Crlf $+ ACCESS # CLEAR OWNER $+ $Crlf $+ ACCESS # CLEAR HOST) 
      }
    }
  }
}

#CLEAR_OWNER_HOST on
#CLEAR_OWNER_HOST end



; Banlist stuff here

alias Aban_Read return $Readini($Aban_File, $$1, $$2)

alias Is_Aban return $Iif($Aban_Read(ABAN, $$1), $True, $False)

alias Is_Aban_Halt return $Iif($Aban_Read(ABAN_HALT, $$1) == Halted, $True, $False) 

alias Add_Aban {
  var %Nick = $$1, %Ial = $Ial(%Nick).addr

  if (!%Ial) {
    echo -ae * No Ial stored for %Nick $+ , //who'ing channel $+ .. please try again.
    sockwrite -n $C_Sock(#) WHO #

    return
  }

  else { 
    if ($Is_Aban(%Ial)) echo -ae * %Nick is already on ABAN.

    else {
      var %Reason = $Input(Please enter an ABAN message for user $Buzz.decode(%Nick) $+ ., qe, ABAN message, You're a dipshit.)

      if (%Reason) {
        writeini $Aban_File ABAN %Ial %Nick %Reason

        if ($Nick(#, $Me, '.@)) {
          if ($Group(#CLEAR_OWNER_HOST) == on) sockwrite -n $C_Sock(#) ACCESS # CLEAR OWNER $+ $Crlf $+ ACCESS # CLEAR HOST
          sockwrite -n $C_Sock(#) KICK # $$1 aban %Nick ; %Reason $+ $Crlf $+ ACCESS # ADD DENY *!* $+ %Ial
        }

        else echo -ae * Added %Nick - %Ial $+ , to ABAN with reason: %Reason
      }
    }
  }
}

alias Remove_Aban {
  var %Nick = $$1, %Ial = $Ial(%Nick).addr, %File = $Aban_File

  if (!%Ial) {
    echo -ae * No Ial stored for %Nick $+ , //who'ing channel $+ .. please try again.
    sockwrite -n $C_Sock(#) WHO #

    return
  }

  else { 
    if ($Is_Aban(%Ial)) {
      remini %File ABAN %Ial
      echo -ae * %Nick has been removed from ABAN.
      msg # * %Nick has been removed from ABAN.
    }

    else echo -ae * %Nick is not even on ABAN.
  }
}

alias Channel_Aban_Scan {
  var %x 1, %b_users = 0

  linesep
  while (%x <= $Nick(#,0)) {
    var %N = $Nick(#,%x), %Ial = $Ial(%N).addr

    if (%Ial) && ($Is_Aban(%Ial)) { 
      echo -a * Found %N $+ , log: $Aban_Read(ABAN, %Ial)
      inc %b_users
    }
    inc %x
  }

  echo -a * 4Found %b_users / $Iif($Ini($Aban_File, ABAN, 0), $Ifmatch, 0) banlisted users, on this channel.
  linesep
}

menu status,channel {
  -
  Moschino[UserlistManager]: Open_Dialog Userlist
}

menu channel {
  Userlist scans/halts
  .Scans
  ..Global +q: Channel_Aop_Scan GLOBALQ
  ..Global +o: Channel_Aop_Scan GLOBALOP
  ..Global +h: Channel_Aop_Scan GLOBALH
  ..-
  ..Local +q: Channel_Aop_Scan LOCALQ
  ..Local +o: Channel_Aop_Scan LOCALOP
  ..Local +h: Channel_Aop_Scan LOCALH
  ..-
  ..Aban: Channel_Aban_Scan
  .-
  .Halts
  ..$Iif($Aop_Read(GLOBALQHALT, #) == Halted, $Style(1)) Halt Global +q: $Iif($Aop_Read(GLOBALQHALT, #) == Halted, $Userlist_Unhalt(GLOBALQ), $Userlist_Halt(GLOBALQ))
  ..$Iif($Aop_Read(GLOBALOPHALT, #) == Halted, $Style(1)) Halt Global +o: $Iif($Aop_Read(GLOBALOPHALT, #) == Halted, $Userlist_Unhalt(GLOBALOP), $Userlist_Halt(GLOBALOP))
  ..$Iif($Aop_Read(GLOBALHHALT, #) == Halted, $Style(1)) Halt Global +h: $Iif($Aop_Read(GLOBALHHALT, #) == Halted, $Userlist_Unhalt(GLOBALH), $Userlist_Halt(GLOBALH))
  ..-
  ..$Iif($Is_Aban_Halt($Active), $Style(1)) Halt banlist: {
    var %F = data/Aban.ini

    if ($Is_Aban_Halt(#)) {
      remini %F ABAN_HALT #
      echo -ae * Aban UNHALTED for this channel.
    }
    else {
      writeini %F ABAN_HALT # Halted
      echo -ae * Aban HALTED for this channel.
    }
  }
  -
}

menu nicklist {
  -
  Userlist
  .Add 
  ..Global +q: Aop_Add $$1 GLOBALQ
  ..Global +o: Aop_Add $$1 GLOBALOP
  ..Global +h: Aop_Add $$1 GLOBALH
  ..-
  ..Local +q: Aop_Add $$1 LOCALQ
  ..Local +o: Aop_Add $$1 LOCALOP
  ..Local +h: Aop_Add $$1 LOCALH
  .-
  .Remove
  ..Global +q: Aop_Delete $$1 GLOBALQ
  ..Global +o: Aop_Delete $$1 GLOBALOP
  ..Global +h: Aop_Delete $$1 GLOBALH
  ..-
  ..Local +q: Aop_Delete $$1 LOCALQ
  ..Local +o: Aop_Delete $$1 LOCALOP
  ..Local +h: Aop_Delete $$1 LOCALH
  .-
  .Add mass select users 
  ..Global +q: Mass_Select_Add GLOBALQ $Snicks
  ..Global +o: Mass_Select_Add GLOBALOP $Snicks
  ..Global +h: Mass_Select_Add GLOBALH $Snicks
  ..-
  ..Local +q: Mass_Select_Add LOCALQ $Snicks
  ..Local +o: Mass_Select_Add LOCALOP $Snicks
  ..Local +h: Mass_Select_Add LOCALH $Snicks
  .-
  .Add banlist: Add_Aban $$1
  .Remove banlist: Remove_Aban $$1
  -
}

; ###########

; GLOBALQ, GLOBALOP, LOCALQ, LOCALOP
; Below are just some sample on*:TEXT events, for anyone who's interested.
; Note, if you want to use these, remove the /* and */

/*
on *:TEXT:*:#: {
  var %Ial = $Ial($Nick).addr, %Sw = sockwrite -n $C_Sock(#) 

  ; GLOBALQ user text commands
  if ($Is_Globalq(%Ial)) {
    if ($1 == .gq) %Sw MODE # +q $Nick 
    elseif ($1 == .aban) Add_Aban 
  }

  ; GLOBALOP user text commands
  elseif ($Is_Globalo(%Ial)) {
    if ($1 == .go) %Sw MODE # +o $Nick
  }

  ; GLOBALH user text commands
  elseif ($Is_Globalh(%Ial)) {
    if ($1 == .gh) %Sw MODE # +h $Nick
  }

  ; LOCALQ user text commands
  elseif ($Is_Localq(%Ial, #)) {
    if ($1 == .lq) %Sw MODE # +q $Nick 
  }

  ; LOCALOP user text commands
  elseif ($Is_Localo(%Ial, #)) {
    if ($1 == .lo) %Sw MODE # +o $Nick 
  }

  ; LOCALH user text commands
  elseif ($Is_Localh(%Ial, #)) {
    if ($1 == .lh) %Sw MODE # +h $Nick 
  }

  ; etc etc..
}
*/
